# -------------------------------------------------
# DocShape
# -------------------------------------------------
QT -= core gui
TARGET = DocShape
TEMPLATE = lib
INCLUDEPATH += ./../../../../inc

DEFINES += CSFDB No_Exception

include(MgtBRep.pri)
include(MgtGeom.pri)
include(MgtGeom2d.pri)
include(MgtPoly.pri)
include(MgtTopLoc.pri)
include(MgtTopoDS.pri)
include(PBRep.pri)
include(PColgp.pri)
include(PColPGeom.pri)
include(PColPGeom2d.pri)
include(PGeom.pri)
include(PGeom2d.pri)
include(PPoly.pri)
include(PTopLoc.pri)
include(PTopoDS.pri)

unix:!macx { 
OPTIMIZE = 3
OPT = -O
    CONFIG(release, debug|release):!isEmpty(OPTIMIZE):*-g++* { 
        QMAKE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_OBJECTIVE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
    }
    HARDWARE_PLATFORM = $$system(uname -m)
    contains( HARDWARE_PLATFORM, x86_64 ) { 
        # 64-bit Linux
        message ("Adding Linux 64 bits compile flags and definitions")
        DEFINES += _OCC64
        QMAKE_CXXFLAGS += -m64
    }
    
    LIBS += -L./../../../../Linux/bin \
    -lKernel \
    -lMath \
    -lG2d \
    -lG3d \
    -lBrep \
    -lDocKernel

    # 32-bit Linux
    DEFINES += LIN LININTEL HAVE_CONFIG_H OCC_CONVERT_SIGNALS NDEBUG
    INCLUDEPATH += ./../../../../
    OBJECTS_DIR = ./../../../../Linux/obj/DocShape
    DESTDIR = ./../../../../Linux/bin
}
win32 { 

    LIBS += ./../../../../Win32/lib/Kernel.lib \
            ./../../../../Win32/lib/Math.lib \
            ./../../../../Win32/lib/G2d.lib \
            ./../../../../Win32/lib/G3d.lib \
            ./../../../../Win32/lib/Brep.lib \
            ./../../../../Win32/lib/DocKernel.lib

    DEFINES += WIN32 WINDOWS WNT _WINDLL

    DEFINES += __MgtBRep_DLL
    DEFINES += __MgtGeom_DLL
    DEFINES += __MgtGeom2d_DLL
    DEFINES += __MgtPoly_DLL
    DEFINES += __MgtTopLoc_DLL
    DEFINES += __MgtTopoDS_DLL
    DEFINES += __PBRep_DLL
    DEFINES += __PColPGeom_DLL
    DEFINES += __PColPGeom2d_DLL
    DEFINES += __PColgp_DLL
    DEFINES += __PGeom_DLL
    DEFINES += __PGeom2d_DLL
    DEFINES += __PPoly_DLL
    DEFINES += __PTopLoc_DLL
    DEFINES += __PTopoDS_DLL

    DEFINES -= UNICODE
    OBJECTS_DIR = ./../../../../Win32/obj/DocShape
    DLLDESTDIR = ./../../../../Win32/bin
    DESTDIR = ./../../../../Win32/lib

#    OPTIMIZE = x
#    OPT = -O
#QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
QMAKE_CXXFLAGS_RELEASE += -wd4996  -wd4100
QMAKE_CXXFLAGS_RTTI_ON  = -Gd
QMAKE_CXXFLAGS_STL_ON   = -EHa
QMAKE_CXXFLAGS_EXCEPTIONS_ON = -EHa
}

macx { 
    DEFINES += OSX # ## is DARWIN a beter choice? Or should we simply use __APPLE__ in the code?
    DEFINES += HAVE_CONFIG_H \
        HAVE_IOSTREAM \
        HAVE_FSTREAM \
        HAVE_LIMITS_H
    QMAKE_LFLAGS_SONAME = -dynamiclib \
        -Wl,-single_module
    QMAKE_CXXFLAGS += -gdwarf-2
    INCLUDEPATH += ./../../
    OBJECTS_DIR = ./../../../../MacOS/obj/DocShape
    DESTDIR = ./../../../../MacOS/bin
}
