# -------------------------------------------------
# DocXCAFSchema
# -------------------------------------------------
QT -= core gui
TARGET = DocXCAFSchema
TEMPLATE = lib
INCLUDEPATH += ./../../../../inc

DEFINES += CSFDB No_Exception

include(MXCAFDoc.pri)
include(PXCAFDoc.pri)
include(XCAFDrivers.pri)
include(XCAFSchema.pri)

unix:!macx { 
OPTIMIZE = 3
OPT = -O
    CONFIG(release, debug|release):!isEmpty(OPTIMIZE):*-g++* { 
        QMAKE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_OBJECTIVE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
    }
    HARDWARE_PLATFORM = $$system(uname -m)
    contains( HARDWARE_PLATFORM, x86_64 ) { 
        # 64-bit Linux
        message ("Adding Linux 64 bits compile flags and definitions")
        DEFINES += _OCC64
        QMAKE_CXXFLAGS += -m64
    }
    
    LIBS += -L./../../../../Linux/bin \
    -lKernel \
    -lMath \
    -lDocCDF \
    -lDocPLCAF \
    -lDocLCAF \
    -lDocXCAF \
    -lDocKernel \
    -lDocShape \
    -lDocShapeSchema \
    -lDocStdSchema \
    -lDocStdLSchema \
    -lG3d

    # 32-bit Linux
    DEFINES += LIN LININTEL HAVE_CONFIG_H OCC_CONVERT_SIGNALS NDEBUG
    INCLUDEPATH += ./../../../../
    OBJECTS_DIR = ./../../../../Linux/obj/DocXCAFSchema
    DESTDIR = ./../../../../Linux/bin
}
win32 { 

    LIBS += ./../../../../Win32/lib/Kernel.lib \
            ./../../../../Win32/lib/Math.lib \
            ./../../../../Win32/lib/DocCDF.lib \
            ./../../../../Win32/lib/DocLCAF.lib \
            ./../../../../Win32/lib/DocPLCAF.lib \
            ./../../../../Win32/lib/DocXCAF.lib \
            ./../../../../Win32/lib/DocKernel.lib \
            ./../../../../Win32/lib/DocShape.lib \
            ./../../../../Win32/lib/DocShapeSchema.lib \
            ./../../../../Win32/lib/DocStdSchema.lib \
            ./../../../../Win32/lib/DocStdLSchema.lib \
            ./../../../../Win32/lib/G3d.lib

    DEFINES += WIN32 WINDOWS WNT _WINDLL

    DEFINES += __MXCAFDoc_DLL
    DEFINES += __PXCAFDoc_DLL
    DEFINES += __XCAFDrivers_DLL
    DEFINES += __XCAFSchema_DLL

    DEFINES -= UNICODE
    OBJECTS_DIR = ./../../../../Win32/obj/DocXCAFSchema
    DLLDESTDIR = ./../../../../Win32/bin
    DESTDIR = ./../../../../Win32/lib

#    OPTIMIZE = x
#    OPT = -O
#QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
QMAKE_CXXFLAGS_RELEASE += -wd4996  -wd4100
QMAKE_CXXFLAGS_RTTI_ON  = -Gd
QMAKE_CXXFLAGS_STL_ON   = -EHa
QMAKE_CXXFLAGS_EXCEPTIONS_ON = -EHa
}

macx { 
    DEFINES += OSX # ## is DARWIN a beter choice? Or should we simply use __APPLE__ in the code?
    DEFINES += HAVE_CONFIG_H \
        HAVE_IOSTREAM \
        HAVE_FSTREAM \
        HAVE_LIMITS_H
    QMAKE_LFLAGS_SONAME = -dynamiclib \
        -Wl,-single_module
    QMAKE_CXXFLAGS += -gdwarf-2
    INCLUDEPATH += ./../../
    OBJECTS_DIR = ./../../../../MacOS/obj/DocXCAFSchema
    DESTDIR = ./../../../../MacOS/bin
}
