# -------------------------------------------------
# Brep
# -------------------------------------------------
QT -= core gui
TARGET = ExpIGES
TEMPLATE = lib
INCLUDEPATH += ./../../../../inc

DEFINES += CSFDB No_Exception

include(BRepToIGES.pri)
include(BRepToIGESBRep.pri)
include(Geom2dToIGES.pri)
include(GeomToIGES.pri)
include(IGESAppli.pri)
include(IGESBasic.pri)
include(IGESControl.pri)
include(IGESConvGeom.pri)
include(IGESData.pri)
include(IGESDefs.pri)
include(IGESDimen.pri)
include(IGESDraw.pri)
include(IGESFile.pri)
include(IGESGeom.pri)
include(IGESGraph.pri)
include(IGESSelect.pri)
include(IGESSolid.pri)
include(IGESToBRep.pri)

unix:!macx { 
OPTIMIZE = 3
OPT = -O
    CONFIG(release, debug|release):!isEmpty(OPTIMIZE):*-g++* { 
        QMAKE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_OBJECTIVE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
    }
    HARDWARE_PLATFORM = $$system(uname -m)
    contains( HARDWARE_PLATFORM, x86_64 ) { 
        # 64-bit Linux
        message ("Adding Linux 64 bits compile flags and definitions")
        DEFINES += _OCC64
        QMAKE_CXXFLAGS += -m64
    }
    
    LIBS += -L./../../../../Linux/bin \
    -lKernel \
    -lMath \
    -lTopAlgo \
    -lShHealing \
    -lG2d \
    -lG3d \
    -lGeomBase \
    -lGeomAlgo \
    -lPrim \
    -lOffset \
    -lBool \
    -lBrep \
    -lXSBase

    # 32-bit Linux
    DEFINES += LIN LININTEL HAVE_CONFIG_H OCC_CONVERT_SIGNALS NDEBUG
    INCLUDEPATH += ./../../../../
    OBJECTS_DIR = ./../../../../Linux/obj/ExpIGES
    DESTDIR = ./../../../../Linux/bin
}
win32 { 

    LIBS += ./../../../../Win32/lib/Kernel.lib \
            ./../../../../Win32/lib/Math.lib \
            ./../../../../Win32/lib/TopAlgo.lib \
            ./../../../../Win32/lib/ShHealing.lib \
            ./../../../../Win32/lib/G2d.lib \
            ./../../../../Win32/lib/G3d.lib \
            ./../../../../Win32/lib/GeomBase.lib \
            ./../../../../Win32/lib/GeomAlgo.lib \
            ./../../../../Win32/lib/Prim.lib \
            ./../../../../Win32/lib/Offset.lib \
            ./../../../../Win32/lib/Bool.lib \
            ./../../../../Win32/lib/Brep.lib \
            ./../../../../Win32/lib/XSBase.lib

    DEFINES += WIN32 WINDOWS WNT _WINDLL

    DEFINES += __BRepToIGES_DLL
    DEFINES += __BRepToIGESBRep_DLL
    DEFINES += __Geom2dToIGES_DLL
    DEFINES += __GeomToIGES_DLL
    DEFINES += __IGESAppli_DLL
    DEFINES += __IGESBasic_DLL
    DEFINES += __IGESControl_DLL
    DEFINES += __IGESConvGeom_DLL
    DEFINES += __IGESData_DLL
    DEFINES += __IGESDefs_DLL
    DEFINES += __IGESDimen_DLL
    DEFINES += __IGESDraw_DLL
    DEFINES += __IGESFile_DLL
    DEFINES += __IGESGeom_DLL
    DEFINES += __IGESGraph_DLL
    DEFINES += __IGESSelect_DLL
    DEFINES += __IGESSolid_DLL
    DEFINES += __IGESToBRep_DLL

    DEFINES -= UNICODE
    OBJECTS_DIR = ./../../../../Win32/obj/ExpIGES
    DLLDESTDIR = ./../../../../Win32/bin
    DESTDIR = ./../../../../Win32/lib

#    OPTIMIZE = x
#    OPT = -O
#QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
QMAKE_CXXFLAGS_RELEASE += -wd4996  -wd4100
QMAKE_CXXFLAGS_RTTI_ON  = -Gd
QMAKE_CXXFLAGS_STL_ON   = -EHa
QMAKE_CXXFLAGS_EXCEPTIONS_ON = -EHa
}

macx { 
    DEFINES += OSX # ## is DARWIN a beter choice? Or should we simply use __APPLE__ in the code?
    DEFINES += HAVE_CONFIG_H \
        HAVE_IOSTREAM \
        HAVE_FSTREAM \
        HAVE_LIMITS_H
    QMAKE_LFLAGS_SONAME = -dynamiclib \
        -Wl,-single_module
    QMAKE_CXXFLAGS += -gdwarf-2
    INCLUDEPATH += ./../../
    OBJECTS_DIR = ./../../../../MacOS/obj/ExpIGES
    DESTDIR = ./../../../../MacOS/bin
}
