# -------------------------------------------------
# ExpSTEP
# -------------------------------------------------
QT -= core gui
TARGET = ExpSTEP
TEMPLATE = lib
INCLUDEPATH += ./../../../../inc

DEFINES += CSFDB No_Exception

include(GeomToStep.pri)
include(RWStepAP203.pri)
include(RWStepAP214.pri)
include(StepAP203.pri)
include(StepAP209.pri)
include(StepAP214.pri)
include(STEPConstruct.pri)
include(STEPControl.pri)
include(STEPEdit.pri)
include(STEPSelections.pri)
include(StepToGeom.pri)
include(StepToTopoDS.pri)
include(TopoDSToStep.pri)

unix:!macx { 
OPTIMIZE = 3
OPT = -O
    CONFIG(release, debug|release):!isEmpty(OPTIMIZE):*-g++* { 
        QMAKE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_OBJECTIVE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
    }
    HARDWARE_PLATFORM = $$system(uname -m)
    contains( HARDWARE_PLATFORM, x86_64 ) { 
        # 64-bit Linux
        message ("Adding Linux 64 bits compile flags and definitions")
        DEFINES += _OCC64
        QMAKE_CXXFLAGS += -m64
    }
    
    LIBS += -L./../../../../Linux/bin \
    -lKernel \
    -lMath \
    -lTopAlgo \
    -lShHealing \
    -lG2d \
    -lG3d \
    -lGeomBase \
    -lGeomAlgo \
    -lBrep \
    -lXSBase \
    -lStepAttrib \
    -lStep209 \
    -lStepBase

    # 32-bit Linux
    DEFINES += LIN LININTEL HAVE_CONFIG_H OCC_CONVERT_SIGNALS NDEBUG
    INCLUDEPATH += ./../../../../
    OBJECTS_DIR = ./../../../../Linux/obj/ExpSTEP
    DESTDIR = ./../../../../Linux/bin
}
win32 { 

    LIBS += ./../../../../Win32/lib/Kernel.lib \
            ./../../../../Win32/lib/Math.lib \
            ./../../../../Win32/lib/TopAlgo.lib \
            ./../../../../Win32/lib/ShHealing.lib \
            ./../../../../Win32/lib/G2d.lib \
            ./../../../../Win32/lib/G3d.lib \
            ./../../../../Win32/lib/GeomBase.lib \
            ./../../../../Win32/lib/GeomAlgo.lib \
            ./../../../../Win32/lib/Brep.lib \
            ./../../../../Win32/lib/XSBase.lib \
            ./../../../../Win32/lib/StepAttrib.lib \
            ./../../../../Win32/lib/Step209.lib \
            ./../../../../Win32/lib/StepBase.lib

    LIBS += wsock32.lib

    DEFINES += WIN32 WINDOWS WNT _WINDLL

    DEFINES += __GeomToStep_DLL
    DEFINES += __RWStepAP203_DLL
    DEFINES += __RWStepAP214_DLL
    DEFINES += __STEPConstruct_DLL
    DEFINES += __STEPControl_DLL
    DEFINES += __STEPEdit_DLL
    DEFINES += __STEPSelections_DLL
    DEFINES += __StepAP203_DLL
    DEFINES += __StepAP209_DLL
    DEFINES += __StepAP214_DLL
    DEFINES += __StepToGeom_DLL
    DEFINES += __StepToTopoDS_DLL
    DEFINES += __TopoDSToStep_DLL

    DEFINES -= UNICODE
    OBJECTS_DIR = ./../../../../Win32/obj/ExpSTEP
    DLLDESTDIR = ./../../../../Win32/bin
    DESTDIR = ./../../../../Win32/lib

#    OPTIMIZE = x
#    OPT = -O
#QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
QMAKE_CXXFLAGS_RELEASE += -wd4996  -wd4100
QMAKE_CXXFLAGS_RTTI_ON  = -Gd
QMAKE_CXXFLAGS_STL_ON   = -EHa
QMAKE_CXXFLAGS_EXCEPTIONS_ON = -EHa
}

macx { 
    DEFINES += OSX # ## is DARWIN a beter choice? Or should we simply use __APPLE__ in the code?
    DEFINES += HAVE_CONFIG_H \
        HAVE_IOSTREAM \
        HAVE_FSTREAM \
        HAVE_LIMITS_H
    QMAKE_LFLAGS_SONAME = -dynamiclib \
        -Wl,-single_module
    QMAKE_CXXFLAGS += -gdwarf-2
    INCLUDEPATH += ./../../
    OBJECTS_DIR = ./../../../../MacOS/obj/ExpSTEP
    DESTDIR = ./../../../../MacOS/bin
}
