# -------------------------------------------------
# Kernel
# -------------------------------------------------
QT -= core gui
TARGET = Math
TEMPLATE = lib
INCLUDEPATH += ./../../../../inc

DEFINES += CSFDB No_Exception

include(Bnd.pri)
include(BSplCLib.pri)
include(BSplSLib.pri)
include(Convert.pri)
include(CSLib.pri)
include(ElCLib.pri)
include(ElSLib.pri)
include(gp.pri)
include(math.pri)
include(PLib.pri)
include(Poly.pri)
include(Precision.pri)
include(TColgp.pri)
include(TopLoc.pri)

unix:!macx { 
OPTIMIZE = 3
OPT = -O
    CONFIG(release, debug|release):!isEmpty(OPTIMIZE):*-g++* { 
        QMAKE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_OBJECTIVE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
    }
    HARDWARE_PLATFORM = $$system(uname -m)
    contains( HARDWARE_PLATFORM, x86_64 ) { 
        # 64-bit Linux
        message ("Adding Linux 64 bits compile flags and definitions")
        DEFINES += _OCC64
        QMAKE_CXXFLAGS += -m64
    }
    
    LIBS += -L./../../../../Linux/bin \
    -lKernel

    # 32-bit Linux
    DEFINES += LIN LININTEL HAVE_CONFIG_H OCC_CONVERT_SIGNALS NDEBUG
    INCLUDEPATH += ./../../../../
    OBJECTS_DIR = ./../../../../Linux/obj/Math
    DESTDIR = ./../../../../Linux/bin
}
win32 { 
    LIBS += ./../../../../Win32/lib/Kernel.lib

    DEFINES += WIN32 WINDOWS WNT _WINDLL

    DEFINES += __BSplCLib_DLL
    DEFINES += __BSplSLib_DLL
    DEFINES += __Bnd_DLL
    DEFINES += __CSLib_DLL
    DEFINES += __Convert_DLL
    DEFINES += __ElCLib_DLL
    DEFINES += __ElSLib_DLL
    DEFINES += __PLib_DLL
    DEFINES += __Poly_DLL
    DEFINES += __Precision_DLL
    DEFINES += __TColgp_DLL
    DEFINES += __TopLoc_DLL
    DEFINES += __gp_DLL
    DEFINES += __math_DLL

    DEFINES -= UNICODE
    OBJECTS_DIR = ./../../../../Win32/obj/Math
    DLLDESTDIR = ./../../../../Win32/bin
    DESTDIR = ./../../../../Win32/lib

#    OPTIMIZE = x
#    OPT = -O
#QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
QMAKE_CXXFLAGS_RELEASE += -wd4996  -wd4100
QMAKE_CXXFLAGS_RTTI_ON  = -Gd
QMAKE_CXXFLAGS_STL_ON   = -EHa
QMAKE_CXXFLAGS_EXCEPTIONS_ON = -EHa
}

macx { 
    DEFINES += OSX # ## is DARWIN a beter choice? Or should we simply use __APPLE__ in the code?
    DEFINES += HAVE_CONFIG_H \
        HAVE_IOSTREAM \
        HAVE_FSTREAM \
        HAVE_LIMITS_H
    QMAKE_LFLAGS_SONAME = -dynamiclib \
        -Wl,-single_module
    QMAKE_CXXFLAGS += -gdwarf-2
    INCLUDEPATH += ./../../
    OBJECTS_DIR = ./../../../../MacOS/obj/Math
    DESTDIR = ./../../../../MacOS/bin
}
