# -------------------------------------------------
# Brep
# -------------------------------------------------
QT -= core gui
TARGET = BO
TEMPLATE = lib
INCLUDEPATH += ./../../../../inc

DEFINES += CSFDB No_Exception

include(BooleanOperations.pri)
include(BOP.pri)
include(BOPTColStd.pri)
include(BOPTools.pri)
include(BRepAlgoAPI.pri)
include(IntTools.pri)

unix:!macx { 
OPTIMIZE = 3
OPT = -O
    CONFIG(release, debug|release):!isEmpty(OPTIMIZE):*-g++* { 
        QMAKE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_OBJECTIVE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
    }
    HARDWARE_PLATFORM = $$system(uname -m)
    contains( HARDWARE_PLATFORM, x86_64 ) { 
        # 64-bit Linux
        message ("Adding Linux 64 bits compile flags and definitions")
        DEFINES += _OCC64
        QMAKE_CXXFLAGS += -m64
    }
    
    LIBS += -L./../../../../Linux/bin \
    -lKernel \
    -lMath \
    -lG2d \
    -lG3d \
    -lGeomBase \
    -lBrep \
    -lGeomAlgo \
    -lTopAlgo

    # 32-bit Linux
    DEFINES += LIN LININTEL HAVE_CONFIG_H OCC_CONVERT_SIGNALS NDEBUG
    INCLUDEPATH += ./../../../../
    OBJECTS_DIR = ./../../../../Linux/obj/BO
    DESTDIR = ./../../../../Linux/bin
}
win32 { 

    LIBS += ./../../../../Win32/lib/Kernel.lib \
            ./../../../../Win32/lib/Math.lib \
            ./../../../../Win32/lib/G2d.lib \
            ./../../../../Win32/lib/G3d.lib \
            ./../../../../Win32/lib/GeomBase.lib \
            ./../../../../Win32/lib/Brep.lib \
            ./../../../../Win32/lib/GeomAlgo.lib \
            ./../../../../Win32/lib/TopAlgo.lib

    DEFINES += WIN32 WINDOWS WNT _WINDLL

    DEFINES += __BOP_DLL
    DEFINES += __BOPTColStd_DLL
    DEFINES += __BOPTools_DLL
    DEFINES += __BRepAlgoAPI_DLL
    DEFINES += __BooleanOperations_DLL
    DEFINES += __IntTools_DLL

    DEFINES -= UNICODE
    OBJECTS_DIR = ./../../../../Win32/obj/BO
    DLLDESTDIR = ./../../../../Win32/bin
    DESTDIR = ./../../../../Win32/lib

#    OPTIMIZE = x
#    OPT = -O
#QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
QMAKE_CXXFLAGS_RELEASE += -wd4996  -wd4100
QMAKE_CXXFLAGS_RTTI_ON  = -Gd
QMAKE_CXXFLAGS_STL_ON   = -EHa
QMAKE_CXXFLAGS_EXCEPTIONS_ON = -EHa
}

macx { 
    DEFINES += OSX # ## is DARWIN a beter choice? Or should we simply use __APPLE__ in the code?
    DEFINES += HAVE_CONFIG_H \
        HAVE_IOSTREAM \
        HAVE_FSTREAM \
        HAVE_LIMITS_H
    QMAKE_LFLAGS_SONAME = -dynamiclib \
        -Wl,-single_module
    QMAKE_CXXFLAGS += -gdwarf-2
    INCLUDEPATH += ./../../
    OBJECTS_DIR = ./../../../../MacOS/obj/BO
    DESTDIR = ./../../../../MacOS/bin
}
