# -------------------------------------------------
# GeomBase
# -------------------------------------------------
QT -= core gui
TARGET = GeomBase
TEMPLATE = lib
INCLUDEPATH += ./../../../../inc

DEFINES += CSFDB No_Exception

include(AdvApp2Var.pri)
include(AppCont.pri)
include(AppDef.pri)
include(AppParCurves.pri)
include(Approx.pri)
include(BndLib.pri)
include(CPnts.pri)
include(Extrema.pri)
include(FEmTool.pri)
include(GC.pri)
include(gce.pri)
include(GCE2d.pri)
include(GCPnts.pri)
include(Geom2dConvert.pri)
include(GeomConvert.pri)
include(GeomLib.pri)
include(GeomProjLib.pri)
include(GeomTools.pri)
include(Hermit.pri)
include(IntAna.pri)
include(IntAna2d.pri)
include(ProjLib.pri)

unix:!macx { 
OPTIMIZE = 3
OPT = -O
    CONFIG(release, debug|release):!isEmpty(OPTIMIZE):*-g++* { 
        QMAKE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_OBJECTIVE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
    }
    HARDWARE_PLATFORM = $$system(uname -m)
    contains( HARDWARE_PLATFORM, x86_64 ) { 
        # 64-bit Linux
        message ("Adding Linux 64 bits compile flags and definitions")
        DEFINES += _OCC64
        QMAKE_CXXFLAGS += -m64
    }
    
    LIBS += -L./../../../../Linux/bin \
    -lKernel \
    -lMath \
    -lG2d \
    -lG3d

    # 32-bit Linux
    DEFINES += LIN LININTEL HAVE_CONFIG_H OCC_CONVERT_SIGNALS NDEBUG
    INCLUDEPATH += ./../../../../
    OBJECTS_DIR = ./../../../../Linux/obj/GeomBase
    DESTDIR = ./../../../../Linux/bin
}
win32 { 

    LIBS += ./../../../../Win32/lib/Kernel.lib \
            ./../../../../Win32/lib/Math.lib \
            ./../../../../Win32/lib/G2d.lib \
            ./../../../../Win32/lib/G3d.lib

    DEFINES += WIN32 WINDOWS WNT _WINDLL

    DEFINES += __AdvApp2Var_DLL
    DEFINES += __AppCont_DLL
    DEFINES += __AppDef_DLL
    DEFINES += __AppParCurves_DLL
    DEFINES += __Approx_DLL
    DEFINES += __BndLib_DLL
    DEFINES += __CPnts_DLL
    DEFINES += __Extrema_DLL
    DEFINES += __FEmTool_DLL
    DEFINES += __GC_DLL
    DEFINES += __GCE2d_DLL
    DEFINES += __GCPnts_DLL
    DEFINES += __Geom2dConvert_DLL
    DEFINES += __GeomConvert_DLL
    DEFINES += __GeomLib_DLL
    DEFINES += __GeomProjLib_DLL
    DEFINES += __GeomTools_DLL
    DEFINES += __Hermit_DLL
    DEFINES += __IntAna_DLL
    DEFINES += __IntAna2d_DLL
    DEFINES += __ProjLib_DLL
    DEFINES += __gce_DLL

    DEFINES -= UNICODE
    OBJECTS_DIR = ./../../../../Win32/obj/GeomBase
    DLLDESTDIR = ./../../../../Win32/bin
    DESTDIR = ./../../../../Win32/lib

#    OPTIMIZE = x
#    OPT = -O
#QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
QMAKE_CXXFLAGS_RELEASE += -wd4996  -wd4100
QMAKE_CXXFLAGS_RTTI_ON  = -Gd
QMAKE_CXXFLAGS_STL_ON   = -EHa
QMAKE_CXXFLAGS_EXCEPTIONS_ON = -EHa
}

macx { 
    DEFINES += OSX # ## is DARWIN a beter choice? Or should we simply use __APPLE__ in the code?
    DEFINES += HAVE_CONFIG_H \
        HAVE_IOSTREAM \
        HAVE_FSTREAM \
        HAVE_LIMITS_H
    QMAKE_LFLAGS_SONAME = -dynamiclib \
        -Wl,-single_module
    QMAKE_CXXFLAGS += -gdwarf-2
    INCLUDEPATH += ./../../
    OBJECTS_DIR = ./../../../../MacOS/obj/GeomBase
    DESTDIR = ./../../../../MacOS/bin
}
