# -------------------------------------------------
# Brep
# -------------------------------------------------
QT -= core gui
TARGET = VisualService
TEMPLATE = lib
INCLUDEPATH += ./../../../../inc

DEFINES += CSFDB No_Exception

include(AlienImage.pri)
include(Aspect.pri)
include(CGM.pri)
include(Image.pri)
include(InterfaceGraphic.pri)
include(MFT.pri)
include(PlotMgt.pri)
include(PS.pri)
include(SelectBasics.pri)
include(TColQuantity.pri)
include(Viewer.pri)

unix:!macx { 
OPTIMIZE = 3
OPT = -O
    CONFIG(release, debug|release):!isEmpty(OPTIMIZE):*-g++* { 
        QMAKE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_OBJECTIVE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
    }
    HARDWARE_PLATFORM = $$system(uname -m)
    contains( HARDWARE_PLATFORM, x86_64 ) { 
        # 64-bit Linux
        message ("Adding Linux 64 bits compile flags and definitions")
        DEFINES += _OCC64
        QMAKE_CXXFLAGS += -m64
    }
    
    LIBS += -L./../../../../Linux/bin \
    -lKernel \
    -lMath \
    -L/usr/X11R6/lib \
    -lXmu

include(Xw.pri)
    # 32-bit Linux
    DEFINES += LIN LININTEL HAVE_CONFIG_H OCC_CONVERT_SIGNALS NDEBUG
    INCLUDEPATH += ./../../../../
    OBJECTS_DIR = ./../../../../Linux/obj/VisualService
    DESTDIR = ./../../../../Linux/bin
}
win32 { 
include(WNT.pri)
    LIBS += ./../../../../Win32/lib/Kernel.lib \
            ./../../../../Win32/lib/Math.lib

    DEFINES += WIN32 WINDOWS WNT _WINDLL

    DEFINES += __AlienImage_DLL
    DEFINES += __Aspect_DLL
    DEFINES += __CGM_DLL
    DEFINES += __Image_DLL
    DEFINES += __InterfaceGraphic_DLL
    DEFINES += __MFT_DLL
    DEFINES += __PS_DLL
    DEFINES += __PlotMgt_DLL
    DEFINES += __SelectBasics_DLL
    DEFINES += __TColQuantity_DLL
    DEFINES += __Viewer_DLL
    DEFINES += __WNT_DLL

    DEFINES -= UNICODE
    OBJECTS_DIR = ./../../../../Win32/obj/VisualService
    DLLDESTDIR = ./../../../../Win32/bin
    DESTDIR = ./../../../../Win32/lib

#    OPTIMIZE = x
#    OPT = -O
#QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
QMAKE_CXXFLAGS_RELEASE += -wd4996  -wd4100
QMAKE_CXXFLAGS_RTTI_ON  = -Gd
QMAKE_CXXFLAGS_STL_ON   = -EHa
QMAKE_CXXFLAGS_EXCEPTIONS_ON = -EHa
}

macx { 
    DEFINES += OSX # ## is DARWIN a beter choice? Or should we simply use __APPLE__ in the code?
    DEFINES += HAVE_CONFIG_H \
        HAVE_IOSTREAM \
        HAVE_FSTREAM \
        HAVE_LIMITS_H
    QMAKE_LFLAGS_SONAME = -dynamiclib \
        -Wl,-single_module
    QMAKE_CXXFLAGS += -gdwarf-2
    INCLUDEPATH += ./../../
    OBJECTS_DIR = ./../../../../MacOS/obj/VisualService
    DESTDIR = ./../../../../MacOS/bin
}
